//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8

//
//
//
//
//

extern string Symbols         = "EURUSD;USDJPY;GBPUSD;USDCAD;USDSEK;USDCHF";
extern string SymbolsPrefix   = "";
extern string SymbolsSuffix   = "";
extern int    CfbDepth        = 5;
extern int    CfbSmooth       = 8;
extern int    CfbPrice        = PRICE_WEIGHTED;
extern color  Color1          = PaleVioletRed;
extern color  Color2          = Violet;
extern color  Color3          = Red;
extern color  Color4          = DeepSkyBlue;
extern color  Color5          = Blue;
extern color  Color6          = Turquoise;
extern color  Color7          = Pink;
extern color  Color8          = Gold;
extern int    LinesWidth      = 2;
extern string UniqueID        = "multi symbols cfb";

//
//
//
//
//

double buffer0[];
double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculating;
string symbols[];
int    size;

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer0);
   SetIndexBuffer(1,buffer1);
   SetIndexBuffer(2,buffer2);
   SetIndexBuffer(3,buffer3);
   SetIndexBuffer(4,buffer4);
   SetIndexBuffer(5,buffer5);
   SetIndexBuffer(6,buffer6);
   SetIndexBuffer(7,buffer7);
      CfbDepth = MathMax(MathMin(CfbDepth,7),1)+7;

      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars  = (Symbols ==  "returnBars"); if (returnBars)  return(0);
      calculating = (Symbols ==  "calculate");  if (calculating) return(0);
      Symbols = StringTrimLeft(StringTrimRight(Symbols));
      if (StringSubstr(Symbols,StringLen(Symbols),1) != ";")
                       Symbols = StringConcatenate(Symbols,";");

         //
         //
         //
         //
         //                                   
            
         int s =  0;
         int i =  StringFind(Symbols,";",s);
         while (i > 0)
         {
            string current = StringSubstr(Symbols,s,i-s);
            ArrayResize(symbols,ArraySize(symbols)+1);
                        symbols[ArraySize(symbols)-1] = current;
            s = i + 1;
            i = StringFind(Symbols,";",s);
         }
         size = MathMin(ArraySize(symbols),8);
         
         //
         //
         //
         //
         //
         
         for (i=0; i<size; i++) symbols[i] = SymbolsPrefix+symbols[i]+SymbolsSuffix;
      
      //
      //
      //
      //
      //
            
   IndicatorShortName(UniqueID);
   return(0);
}

//
//
//
//
//

int deinit()
{
   for(int i = 0; i < 8; i++) ObjectDelete(UniqueID+ i);
   return (0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,j,k,r,y,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit  = MathMin(Bars-counted_bars,Bars-1);
         if (calculating){ calculateCfb();       return(0); }
         if (returnBars) { buffer0[0] = limit+1; return(0); }
         
            //
            //
            //
            //
            //
            
            static bool initialized = false;
            if (!initialized)
            {
               initialized = true;
               int cur = 10; 
               int cuy = 10; 
               int st  = 16;
                  if (size>0) { mark(0,"~",cur,cuy,Color1,symbols[0]); cuy += st; }
                  if (size>1) { mark(1,"~",cur,cuy,Color2,symbols[1]); cuy += st; }
                  if (size>2) { mark(2,"~",cur,cuy,Color3,symbols[2]); cuy += st; }
                  if (size>3) { mark(3,"~",cur,cuy,Color4,symbols[3]); cuy += st; }
                  if (size>4) { mark(4,"~",cur,cuy,Color5,symbols[4]); cuy += st; }
                  if (size>5) { mark(5,"~",cur,cuy,Color6,symbols[5]); cuy += st; }
                  if (size>6) { mark(6,"~",cur,cuy,Color7,symbols[6]); cuy += st; }
                  if (size>7) { mark(7,"~",cur,cuy,Color8,symbols[7]); cuy += st; }
            }

   //
   //
   //
   //
   //

   for (i=0; i<size; i++) if (symbols[i]!=Symbol()) limit = MathMax(limit,MathMin(Bars-1,iCustom(symbols[i],0,indicatorFileName,"returnBars",0,0)));
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      for (k=0; k<size; k++)
      {
         y = iBarShift(symbols[k],0,Time[i]); 
         switch(k)
         {
            case 0 : buffer0[i] = iCustom(symbols[k],0,indicatorFileName,"calculate","","",CfbDepth-7,CfbSmooth,CfbPrice,0,y); break;
            case 1 : buffer1[i] = iCustom(symbols[k],0,indicatorFileName,"calculate","","",CfbDepth-7,CfbSmooth,CfbPrice,0,y); break;
            case 2 : buffer2[i] = iCustom(symbols[k],0,indicatorFileName,"calculate","","",CfbDepth-7,CfbSmooth,CfbPrice,0,y); break;
            case 3 : buffer3[i] = iCustom(symbols[k],0,indicatorFileName,"calculate","","",CfbDepth-7,CfbSmooth,CfbPrice,0,y); break;
            case 4 : buffer4[i] = iCustom(symbols[k],0,indicatorFileName,"calculate","","",CfbDepth-7,CfbSmooth,CfbPrice,0,y); break;
            case 5 : buffer5[i] = iCustom(symbols[k],0,indicatorFileName,"calculate","","",CfbDepth-7,CfbSmooth,CfbPrice,0,y); break;
            case 6 : buffer6[i] = iCustom(symbols[k],0,indicatorFileName,"calculate","","",CfbDepth-7,CfbSmooth,CfbPrice,0,y); break;
            case 7 : buffer7[i] = iCustom(symbols[k],0,indicatorFileName,"calculate","","",CfbDepth-7,CfbSmooth,CfbPrice,0,y); break;
         }            
      }
   }     
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int    Depths[] = {2,3,4,6,8,12,16,24,32,48,64,96,128,192};
double workCfb[][29];

void calculateCfb()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for (int i=limit; i>=0; i--) buffer0[i] = iCfb(iMA(NULL,0,1,0,MODE_SMA,CfbPrice,i),CfbDepth,CfbSmooth,i);
}   

//
//
//
//
//

double iCfb(double price, int depth, int smooth, int i)
{
   if (ArrayRange(workCfb,0) != Bars) ArrayResize(workCfb,Bars);
   i = Bars-i-1;
         
   //
   //
   //
   //
   //

   double suma     = 0;
   double sumb     = 0;
   double cfb      = 0;
   double evenCoef = 1;
   double oddCoef  = 1;
   double avg      = 0;
         
      if (i>=smooth)
         for (int k=depth-1; k>=0; k--)
         {
            workCfb[i][k]    = iCfbFunc(price,i,Depths[k],k);
            workCfb[i][k+14] = workCfb[i-1][k+14] + (workCfb[i][k]-workCfb[i-smooth][k])/smooth;

                  if ((k%2)==0)
                        { avg = oddCoef  * workCfb[i][k+14]; oddCoef  = oddCoef  * (1 - avg); }
                  else  { avg = evenCoef * workCfb[i][k+14]; evenCoef = evenCoef * (1 - avg); }
               
               suma += avg*avg*Depths[k];
               sumb += avg;
         }
      else for (k=depth-1; k>=0; k--) { workCfb[i][k] = 0; workCfb[i][k+14] = 0; }            

   //
   //
   //
   //
   //

   if (sumb != 0) cfb = suma/sumb;
   return(cfb);
}

//
//
//
//
//

double  workCfbFunc[][70];
#define _prices 0
#define _roc    1
#define _value1 2
#define _value2 3
#define _value3 4

//
//
//
//

double iCfbFunc(double price, int r, int depth, int k)
{
   k *= 5;
      if (ArrayRange(workCfbFunc,0) != Bars) ArrayResize(workCfbFunc,Bars);
      if (r<=(depth+1))
      {
         workCfbFunc[r][k+_prices] = 0;
         workCfbFunc[r][k+_roc]    = 0;
         workCfbFunc[r][k+_value1] = 0;
         workCfbFunc[r][k+_value2] = 0;
         workCfbFunc[r][k+_value3] = 0;
         return(0);
      }         
      workCfbFunc[r][k+_prices] = price; 

   //
   //
   //
   //
   //

      workCfbFunc[r][k+_roc]    = MathAbs(workCfbFunc[r][k+_prices] - workCfbFunc[r-1][k+_prices]);
      workCfbFunc[r][k+_value1] = workCfbFunc[r-1][k+_value1] - workCfbFunc[r-depth][k+_roc] + workCfbFunc[r][k+_roc];
      workCfbFunc[r][k+_value2] = workCfbFunc[r-1][k+_value2] - workCfbFunc[r-1][k+_value1] + workCfbFunc[r][k+_roc]*depth;
      workCfbFunc[r][k+_value3] = workCfbFunc[r-1][k+_value3] - workCfbFunc[r-1-depth][k+_prices] + workCfbFunc[r-1][k+_prices];
   
      double dividend = MathAbs(depth*workCfbFunc[r][k+_prices]-workCfbFunc[r][k+_value3]);

      //
      //
      //
      //
      //
         
   if (workCfbFunc[r][k+_value2] != 0)
         return( dividend / workCfbFunc[r][k+_value2]);
   else  return(0.00);            
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void mark(int buffNo, string sym, int x, int y, color col, string buffLabel)
{
   int    window = WindowFind(UniqueID);
   string ID = UniqueID + buffNo;
   
      if(ObjectCreate(ID, OBJ_LABEL, window, 0, 0))
            ObjectSet(ID, OBJPROP_CORNER, 1);
            ObjectSet(ID, OBJPROP_XDISTANCE, x);
            ObjectSet(ID, OBJPROP_YDISTANCE, y);
            ObjectSetText(ID, buffLabel, 10, "Arial Bold", col);

   SetIndexStyle(buffNo,DRAW_LINE,STYLE_SOLID,LinesWidth,col);
   SetIndexLabel(buffNo,buffLabel);
}